import { _decorator, Component, Input, Vec3, input,  game, Node } from 'cc';
import { globalVars } from './globalVars';
const { ccclass, property } = _decorator;

@ccclass('cameraScript')
export class cameraScript extends Component {

    /* Local Variables */

        private mouseXSensitvity: number = 8;
        private mouseYSensitvity: number = 5;
        private mousePos = new Vec3(0, 0, 0);

    /* End Local Variables */

    start() {
        globalVars.start = 0;
        globalVars.camera = this;
        document.addEventListener('pointerlockchange', this.lockChange, false);
        input.on(Input.EventType.MOUSE_MOVE, this.onMouseMove, this);
        input.on(Input.EventType.MOUSE_UP, this.onMouseUp, this);
    }

    update(deltaTime: number) {
        this.node.setPosition(globalVars.character.node.getPosition());
        if(globalVars.start == 1){
            if(this.mousePos.x >= 300 && this.mousePos.x <= 500){
                this.node.setRotationFromEuler(this.mousePos);
            } else if(this.mousePos.x < 300){
                this.node.setRotationFromEuler(300, this.mousePos.y,0);
            } else if(this.mousePos.x > 500){
                this.node.setRotationFromEuler(500, this.mousePos.y,0);
            }
            globalVars.character.node.setRotationFromEuler(new Vec3(0, this.mousePos.y, 0));
        }
    }

    onMouseUp(event:EventMouse){
        if(globalVars.start == 0){
            if (game.canvas.requestPointerLock) {
                game.canvas.requestPointerLock();
            }
        }
    }

    lockChange() {
        if (document.pointerLockElement === game.canvas ) {
          globalVars.start = 1;
        } else {
          globalVars.start = 3;
          setTimeout( () => { globalVars.start = 0; }, 1800 );
        }
    }

    onMouseMove(event:EventMouse){
        this.mousePos.x = 330 + event.getLocation().y/this.mouseXSensitvity;
        this.mousePos.y = -event.getLocation().x/this.mouseYSensitvity;
    }
}