System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, math, _dec, _class, _crd, ccclass, property, globalVars;

  function SmoothDamp(current, target, currentVelocity, smoothTime, maxSpeed, deltaTime) {
    if (maxSpeed === void 0) {
      maxSpeed = Infinity;
    }

    deltaTime = Math.max(0.0001, deltaTime); // Based on Game Programming Gems 4 Chapter 1.10

    smoothTime = Math.max(0.0001, smoothTime);
    var omega = 2 / smoothTime;
    var x = omega * deltaTime;
    var exp = 1 / (1 + x + 0.48 * x * x + 0.235 * x * x * x);
    var change = current - target;
    var originalTo = target; // Clamp maximum speed

    var maxChange = maxSpeed * smoothTime;
    change = math.clamp(change, -maxChange, maxChange);
    target = current - change;
    var temp = (currentVelocity[0] + omega * change) * deltaTime;
    currentVelocity[0] = (currentVelocity[0] - omega * temp) * exp;
    var result = target + (change + temp) * exp; // Prevent overshooting

    if (originalTo - current > 0.0 == result > originalTo) {
      result = originalTo;
      currentVelocity[0] = (result - originalTo) / deltaTime;
    }

    return result;
  }

  _export("SmoothDamp", SmoothDamp);

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      math = _cc.math;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "ee02cU0FrlHAaK517mF6ygN", "globalVars", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("globalVars", globalVars = (_dec = ccclass('globalVars'), _dec(_class = class globalVars extends Component {
        constructor() {
          super(...arguments);
          this.character = void 0;
          this.camera = void 0;
          this.start = 0;
        }
        /* End Global Variables */


      }) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=e85e575b95b1123fb527b3f5b969304a7bd30043.js.map